//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================




#include "CPsyMudApp.h"
#include "CPsyMudCmdDrop.h"
#include "CPsyMudLog.h"
#include "CPsyMudItem.h"
#include "color.h"
#include <stdio.h>		// for sprintf

CPsyMudCmdDrop::CPsyMudCmdDrop()
		: CPsyMudCommand("drop", "Environment", "usage: drop item\n\r       Attempt to drop an item into the current room.\n\r")
{
}

void CPsyMudCmdDrop::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	static string sMsg ;

	if (pch->IsSleeping())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("You can't do that while you are sleeping.\r\n") ;
	}
	else
	{
		if (sRestOfCommandLine == "")
		{
			pch->GetConnectionInfo()->AddToOutputBuffer("Drop what?\r\n") ;
		}
		else
		{
			CPsyMudItem * o ;

				// find the object in the current room
			o = pch->GetInventory()->GetItemByName(sRestOfCommandLine) ;

			if (o)
			{
				// put item in inventory
				pch->GetInventory()->RemoveItem(o) ;

				// add item room
				pch->GetLocation()->GetItems()->AddItem(o) ;

				// tell this player
				sMsg = "You drop " + o->GetShortDescription() + ".\r\n" ;
				pch->GetConnectionInfo()->AddToOutputBuffer(sMsg) ;

				// tell other players


			}
			else
			{
				sMsg = "You don't seem to have '" + sRestOfCommandLine + "'.\r\n" ;

				pch->GetConnectionInfo()->AddToOutputBuffer(sMsg) ;
			}
		}
	}
}