//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================



#include "CPsyMudApp.h"
#include "CPsyMudCmdGet.h"
#include "CPsyMudLog.h"
#include "CPsyMudItem.h"
#include "color.h"
#include <stdio.h>		// for sprintf

CPsyMudCmdGet::CPsyMudCmdGet()
		: CPsyMudCommand("get", "Environment", "usage: get item\n\r       Attempt to pick up an item and put it in your inventory.\n\r")
{
}

void CPsyMudCmdGet::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	static string sMsg ;

	if (pch->IsSleeping())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("Some Z's are about all you can get right now.\r\n") ;
	}
	else
	{
		if (sRestOfCommandLine == "")
		{
			pch->GetConnectionInfo()->AddToOutputBuffer("Get what?\r\n") ;
		}
		else
		{
			CPsyMudItem * o ;

				// find the object in the current room
			o = pch->GetLocation()->GetItems()->GetItemByName(sRestOfCommandLine) ;

			if (o)
			{
				// see if we can see the item

				// we can see the item, try to pick it up

				// TO DO: Check weight, size, etc.

				// see if we can see this item

				// put item in inventory
				pch->GetInventory()->AddItem(o) ;

				// remove item from room
				pch->GetLocation()->GetItems()->RemoveItem(o) ;

				// tell this player
				sMsg = "You put " + o->GetShortDescription() + " in your inventory.\r\n" ;
				pch->GetConnectionInfo()->AddToOutputBuffer(sMsg) ;

				// tell other players


			}
			else
			{
				sMsg = "You don't see any '" + sRestOfCommandLine + "' here.\r\n" ;

				pch->GetConnectionInfo()->AddToOutputBuffer(sMsg) ;
			}
		}
	}
}