//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version. Pleae keep all headers and
// documentation (including development credits) intact.
//
//=======================================================================



#include "CPsyMudApp.h"
#include "CPsyMudCmdInventory.h"
#include "CPsyMudLog.h"
#include "color.h"
#include "CPsyMudItem.h"
#include <stdio.h>		// for sprintf

CPsyMudCmdInventory::CPsyMudCmdInventory()
		: CPsyMudCommand("inventory", "Information", "usage: inventory\n\r       Show what I am carrying in my inventory.\n\r")
{
}

void CPsyMudCmdInventory::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	static string sMsg ;

	if (pch->IsSleeping())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("Better wake up first.\r\n") ;
	}
	else
	{
		if (sRestOfCommandLine == "")
		{
			int iNumItems = 0 ;

			pch->GetConnectionInfo()->AddToOutputBuffer(COLOR_DARK_CYAN +  string("You are carrying the following items\r\n") + COLOR_NORMAL) ;

			for (list<CPsyMudItem *>::const_iterator p = pch->GetInventory()->GetItemList()->begin() ; p != pch->GetInventory()->GetItemList()->end() ; p++)
			{
				//if (typename(**p) == "CPsyMudItem")
				{
					pch->GetConnectionInfo()->AddToOutputBuffer("  " + ((CPsyMudItem *)(*p))->GetShortDescription() + "\r\n") ;
				}
				//else
				//{
				//	pch->GetConnectionInfo()->AddToOutputBuffer(string("  ERROR: Unsupported object type " + string("\r\n")) ;
				//}

				iNumItems++ ;
			}

			if (iNumItems == 0)
			{
				pch->GetConnectionInfo()->AddToOutputBuffer("  Nothing.\r\n") ;			
			}
		}
		else
		{
	
			// TEMP!  Here we would lookup the object/description/player in the
			// current room and then display its description
			sMsg = "You can only look at your own inventory.\r\n" ;

			pch->GetConnectionInfo()->AddToOutputBuffer(sMsg) ;
		}
	}
}

