//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================

#include <string>
#include "CPsyMudApp.h"

#include "CPsyMudCmdRest.h"

#include "CPsyMudLog.h"

CPsyMudCmdRest::CPsyMudCmdRest()
		: CPsyMudCommand("rest", "Environment", "usage: rest [item]\n\r       Rest (optionally) on an item.\n\r")
{
}

void CPsyMudCmdRest::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	if (pch->IsSleeping())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("You're already sleeping.\r\n") ;
	}
	else if (pch->IsResting())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("You're already resting.\r\n") ;		
	}
	else if (pch->IsFighting())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("Rest while you're fighting?  Are you mad!?.\r\n") ;		
	}
	else
	{
		string sMsg ;
		sMsg = pch->GetName() + " rests.\r\n" ;
		g_Mud.RoomMessage(sMsg, pch->GetLocation(), pch) ;

		pch->GetConnectionInfo()->AddToOutputBuffer("You rest your tired bones.\r\n") ;		
		pch->SetPosition(CPsyMudCharacter::cpResting) ;
	}
}