//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#include <string>
#include "CPsyMudApp.h"

#include "CPsyMudLog.h"
#include "CPsyMudCmdSay.h"

#include "color.h"

#include <stdio.h>	// for sprintf

CPsyMudCmdSay::CPsyMudCmdSay()
		: CPsyMudCommand("say", "Communication", "usage: say <message>\n\r       Say something to other players in the room.\n\r")
{
}

void CPsyMudCmdSay::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	string sMsg ;

	if (sRestOfCommandLine == "")
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("Say what?\r\n") ;
	}
	else
	{
		sMsg = COLOR_BRIGHT_GREEN + pch->GetName() + string(" says '") + COLOR_NORMAL + sRestOfCommandLine + COLOR_BRIGHT_GREEN + string("'\r\n") + COLOR_NORMAL ;
		g_Mud.RoomMessage(sMsg, pch->GetLocation(), pch) ;
		pch->GetConnectionInfo()->AddToOutputBuffer("You say '" + sRestOfCommandLine + "'\r\n") ;
	}

}
