//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#include "CPsyMudLog.h"

#include "CPsyMudCmdScore.h"
#include <stdio.h>	// for sprintf

CPsyMudCmdScore::CPsyMudCmdScore()
		: CPsyMudCommand("score", "Character", "usage: score\n\r       Displays player score.\n\r")
{
}

void CPsyMudCmdScore::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	string 	sScore ;
	static char 	sLine[150] ;


	sprintf(sLine, "Alignment       : %d\r\n", pch->GetPoints()->GetAlignment()) ;
	sScore += sLine ;
	sprintf(sLine, "Experience      : %ld\r\n", pch->GetPoints()->GetExperience()) ;
	sScore += sLine ;
	sprintf(sLine, "Hit Points      : %d / %d\r\n", pch->GetPoints()->GetCurrentHitPoints(), pch->GetPoints()->GetMaxHitPoints()) ;
	sScore += sLine ;
	sprintf(sLine, "Movement Points : %d / %d\r\n", pch->GetPoints()->GetCurrentMovementPoints(), pch->GetPoints()->GetMaxMovementPoints()) ;
	sScore += sLine ;
	sprintf(sLine, "Mana Points     : %d / %d\r\n", pch->GetPoints()->GetCurrentMana(), pch->GetPoints()->GetMaxMana()) ;
	sScore += sLine ;

	pch->GetConnectionInfo()->AddToOutputBuffer(sScore) ;

}
