//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#include <string>
#include "CPsyMudApp.h"

#include "CPsyMudCmdSit.h"

#include "CPsyMudLog.h"

CPsyMudCmdSit::CPsyMudCmdSit()
		: CPsyMudCommand("sit", "Environment", "usage: sit [item]\n\r       Sit down (optionally) on an item.\n\r")
{
}

void CPsyMudCmdSit::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	if (pch->IsSleeping())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("You're fast asleep.\r\n") ;
	}
	else if (pch->IsResting())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("You stop resting and sit up.\r\n") ;		
		pch->SetPosition(CPsyMudCharacter::cpSitting) ;
	}
	else if (pch->IsFighting())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("Sit while you're fighting?  Are you mad!?.\r\n") ;		
	}
	else
	{
		string sMsg ;
		sMsg = pch->GetName() + " sits down.\r\n" ;
		g_Mud.RoomMessage(sMsg, pch->GetLocation(), pch) ;

		pch->GetConnectionInfo()->AddToOutputBuffer("You sit down.\r\n") ;		
		pch->SetPosition(CPsyMudCharacter::cpSitting) ;
	}
}