//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#include <string>
#include "CPsyMudApp.h"

#include "CPsyMudCmdSleep.h"

#include "CPsyMudLog.h"

CPsyMudCmdSleep::CPsyMudCmdSleep()
		: CPsyMudCommand("sleep", "Environment", "usage: sleep [item]\n\r       Sleep (optionally) on an item.\n\r")
{
}

void CPsyMudCmdSleep::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	if (pch->IsSleeping())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("You're already sleeping.\r\n") ;
	}
	else if (pch->IsFighting())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("Sleep while you're fighting?  Is the battle really that boring?.\r\n") ;		
	}
	else
	{
		string sMsg ;
		sMsg = pch->GetName() + " lies down and goes to sleep.\r\n" ;
		g_Mud.RoomMessage(sMsg, pch->GetLocation(), pch) ;

		pch->GetConnectionInfo()->AddToOutputBuffer("You shut your eyes and go to sleep.\r\n") ;		
		pch->SetPosition(CPsyMudCharacter::cpSleeping) ;
	}
}
