//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#include <string>
#include "CPsyMudApp.h"

#include "CPsyMudLog.h"

#include "CPsyMudCmdWake.h"


CPsyMudCmdWake::CPsyMudCmdWake()
		: CPsyMudCommand("wake", "Environment", "usage: wake\n\r       Wake up.\n\r")
{
}

void CPsyMudCmdWake::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	if (pch->IsSleeping())
	{
		string sMsg ;
		sMsg = pch->GetName() + " wakes up and sits up.\r\n" ;
		g_Mud.RoomMessage(sMsg, pch->GetLocation(), pch) ;

		pch->GetConnectionInfo()->AddToOutputBuffer("You wake and sit up.\r\n") ;
		pch->SetPosition(CPsyMudCharacter::cpSitting) ;
	}
	else if (pch->IsFighting())
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("I would certainly hope that in the heat of battle, you are already awake!\r\n") ;		
	}
	else
	{
		pch->GetConnectionInfo()->AddToOutputBuffer("You're already awake.\r\n") ;		
	}
}
