//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================




#include "CPsyMudApp.h"
#include "CPsyMudCmdWho.h"
#include "CPsyMudLog.h"
#include "color.h"
#include "CPsyMudRoom.h"
#include "CPsyMudPCharacter.h"
#include <stdio.h>		// for sprintf

CPsyMudCmdWho::CPsyMudCmdWho()
		: CPsyMudCommand("who", "Informational", "usage: who\n\r       List all players currently in the game.\n\r")
{
}

void CPsyMudCmdWho::ProcessCommand(const string& sRestOfCommandLine, CPsyMudPCharacter * pch)
{
	static string sMsg ;
	int		iPlayerCount = 0 ;
	char	szPlayerCount[6] ;

	if (sRestOfCommandLine == "")
	{
		sMsg = "" ;
		sMsg += COLOR_DARK_CYAN + string("Players Current in the Mud\n\r") + COLOR_NORMAL ;
		sMsg += COLOR_DARK_YELLOW + string("---------------------------------------------------------------------------\n\r") + COLOR_NORMAL ;


		// TO DO : loop through *sorted* list of players

		for (vector<CPsyMudPCharacter *>::const_iterator p = g_Mud.GetActivePlayerList()->begin() ; p != g_Mud.GetActivePlayerList()->end() ; p++)
		{
			sMsg += (*p)->GetName() + COLOR_NORMAL ;
			sMsg += "\r\n" ;

			iPlayerCount++ ;
		}

		sprintf(szPlayerCount, "%u", iPlayerCount) ;

		sMsg += COLOR_DARK_CYAN ;

		if (iPlayerCount > 1)
		{
			sMsg += string(szPlayerCount) + " players listed.\n\r" ;
		}
		else
		{
			sMsg += "Only one lonely player listed.\n\r" ;
		}

		sMsg += COLOR_NORMAL ;

		pch->GetConnectionInfo()->AddToOutputBuffer(sMsg) ;
			
	}
	else
	{
	
		// TEMP!  Here we would lookup the object/description/player in the
		// current room and then display its description
		sMsg = "Who with options not currently implemented .\r\n" ;

		pch->GetConnectionInfo()->AddToOutputBuffer(sMsg.c_str()) ;
	}
}