//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================



#ifndef CPSYMUDLOG_H
#define CPSYMUDLOG_H

#include <fstream.h>
#include <string>
#include <exception>
//#include <varargs.h>

//#include "mudversion.h"

#define MUDLOGFILENAME "log/psymud"
#define MAX_LOG_MESSAGE_SIZE 200
#define MUD_LOG_TIMESTAMP_SIZE 20

class CPsyMudLogException : public exception
{
private:
	string sErrorString ;	//description of exception
public:
	CPsyMudLogException(char * szWhat) : sErrorString(szWhat) {}

	virtual const char *what() const
	{
		return sErrorString.c_str() ;
	}
	
} ;


class CPsyMudLog
{
private:
	fstream 	m_LogFile ;
	char 		m_szMessageWorkArea[MAX_LOG_MESSAGE_SIZE] ;
	static int	m_iNumInstances ;

	string * GetTimeStamp() ;

public:

	enum LogType
	{
		logGeneral,
		logError,
		logSecurity,
		logSpecialCommands,
		logRestart,
		logNewPlayer,
		logTrace
	} ;


	CPsyMudLog(char * szLogFileName = MUDLOGFILENAME) throw(CPsyMudLogException) ;
	~CPsyMudLog() ;

	void Log(LogType typ, char * pszFormat, ...) throw(CPsyMudLogException) ;

} ;

extern CPsyMudLog g_Log ;



#endif	// ifndef CPSYMUDLOG_H