//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================



#ifndef CPSYMUDOBJECT_H
#define CPSYMUDOBJECT_H

#include <string>
#include <vector>

//#include <exception>
//#include "CPsyMudLog.h"

class CPsyMudObject
{
private:
	unsigned long 	m_ulObjectID ;			// uniquely identifies this object in the database
	string			m_sCreatedBy ;			// who originally created this object	
	
	//struct datetime	m_dtCreatedOn ;

public:
	CPsyMudObject() 											{ m_ulObjectID = 0 ; }
	CPsyMudObject(const CPsyMudObject& arg)						{ m_ulObjectID = arg.GetObjectID() ; return ;}
	virtual ~CPsyMudObject() 									{ }

	unsigned long 	GetObjectID() const							{ return m_ulObjectID ; }
	void			SetObjectID(const unsigned long iNewValue)	{ m_ulObjectID = iNewValue ; return ; }
	
	const string	GetObjectIDAsString() const	;

	virtual void SerializeIn(void * data) = 0 ;
	virtual void SerializeOut(void * data) = 0 ;

} ;

#endif		// #ifndef CPSYMUDOBJECT_H