//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================

#include "CPsyMudObjectContainer.h"

// returns items only
CPsyMudItem *	CPsyMudItemContainer::GetItemByName(const string& sName)
{
	for (list<CPsyMudItem *>::const_iterator p = m_Items.begin() ; p != m_Items.end() ; p++)
	{
		if ((*p)->HasAlias(sName))
		{
			return (*p) ;
		}
	}
	
	return NULL ;
}

// returns any type of object
CPsyMudItem * CPsyMudItemContainer::GetItemByID(const unsigned long lID)
{
	for (list<CPsyMudItem *>::const_iterator p = m_Items.begin() ; p != m_Items.end() ; p++)
	{
		if ((*p)->GetObjectID() == lID)
		{
			return (*p) ;
		}
	}

	return NULL ;
}


void CPsyMudItemContainer::RemoveItem(const CPsyMudItem * itm)
{
	for (list<CPsyMudItem *>::iterator p = m_Items.begin() ; p != m_Items.end() ; p++)
	{
		// compare pointers
		if (*p == itm)
		{
			m_Items.erase(p) ;

			return ;
		}
	}
	
}



