//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================

#ifndef CPSYMUDOBJECTCONTAINER_H
#define CPSYMUDOBJECTCONTAINER_H
#include <list>
#include "CPsyMudItem.h"

class CPsyMudItemContainer
{
private:
	list<CPsyMudItem *> m_Items ;	

public:
	inline const list<CPsyMudItem *> * 	GetItemList() 	const	{ return &m_Items ; }

	inline void 	AddItem(const CPsyMudItem * itm)			{ m_Items.insert(m_Items.end(), itm) ; }
	

	//TODO: need methods to find item in list, and remove item in list
	CPsyMudItem *		GetItemByName(const string& sName) ;
	CPsyMudItem * 		GetItemByID(const unsigned long lID) ;
	void				RemoveItem(const CPsyMudItem * itm) ;
	const unsigned long	Count() const 								{ return m_Items.size() ; }

} ;

#endif	// #define CPSYMUDOBJECTCONTAINER_H
