//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#ifndef CPSYMUDROOM_H
#define CPSYMUDROOM_H

#include <string>
#include <vector>
#include "CPsyMudObject.h"
#include "CPsyMudRoomExit.h"
#include "CPsyMudObjectContainer.h"


//#define MAX_ROOM_EXITS	15

class CPsyMudRoom : public CPsyMudObject
{
private:
	string	m_sName ;							// name of this room
	string	m_sDescription ;					// the full room description

	// need a list of "extra" descriptions here
	vector <CPsyMudRoomExit *> 	m_Exits ;		
	
	CPsyMudItemContainer	m_Items ;			// list of items in the room
	

public:
	CPsyMudRoom() 			{}
	virtual ~CPsyMudRoom() 	{}
	
	inline const string GetDescription() const				{ return m_sDescription ; }
	inline void			SetDescription(const string& s)		{ m_sDescription = s ; }

	inline const string GetName() const						{ return m_sName ; }
	inline void			SetName(const string& s)			{ m_sName = s ; }

	bool AddExit(CPsyMudRoomExit * ExitToAdd) ;
	bool RemoveExitByName(const char * szName) ;

	CPsyMudRoomExit * GetExitByName(const char * szName) const ;

	const vector<CPsyMudRoomExit *> * GetExitList() const	{ return &m_Exits ; }
	const CPsyMudItemContainer * GetItems() const				{ return &m_Items ; }


	void SerializeIn(void * data) 	{}
	void SerializeOut(void * data) 	{}
} ;

#endif