//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#include "CPsyMudRoomExit.h"
#include "CPsyMudRoom.h"

CPsyMudRoomExit::CPsyMudRoomExit()
{
	m_bDefaultLocked = false ;
	m_bDefaultClosed  = false ;

	m_bCurrentlyLocked  = m_bDefaultLocked ;
	m_bCurrentlyClosed  = m_bDefaultClosed ;

	m_sDirectionName = "" ;
	m_sDescription = "" ;

	m_sMyExitMessage = "" ;
	m_sOtherExitMessage = "" ;
	m_sMyEnterMessage = "" ;
	m_sOtherEnterMessage = "" ;

	m_ulTemporaryDest = 0 ;
	m_Destination = NULL ;
}

CPsyMudRoomExit::CPsyMudRoomExit(const CPsyMudRoomExit& copy)
{
	m_sDirectionName = copy.m_sDirectionName ;
	m_sDescription = copy.m_sDescription ;

	m_Destination = copy.m_Destination ;

	m_bDefaultLocked = copy.m_bDefaultLocked ;
	m_bDefaultClosed  = copy.m_bDefaultClosed ;

	m_bCurrentlyLocked  = copy.m_bCurrentlyLocked ;
	m_bCurrentlyClosed  = copy.m_bCurrentlyClosed ;

	m_sMyExitMessage = copy.m_sMyExitMessage ;
	m_sOtherExitMessage = copy.m_sOtherExitMessage ;
	m_sMyEnterMessage = copy.m_sMyEnterMessage ;
	m_sOtherEnterMessage = copy.m_sOtherEnterMessage ;

}

CPsyMudRoomExit& CPsyMudRoomExit::operator = (const CPsyMudRoomExit& rhs)
{
	m_sDirectionName = rhs.m_sDirectionName ;
	m_sDescription = rhs.m_sDescription ;

	m_Destination = rhs.m_Destination ;

	m_bDefaultLocked = rhs.m_bDefaultLocked ;
	m_bDefaultClosed  = rhs.m_bDefaultClosed ;

	m_bCurrentlyLocked  = rhs.m_bCurrentlyLocked ;
	m_bCurrentlyClosed  = rhs.m_bCurrentlyClosed ;

	m_sMyExitMessage = rhs.m_sMyExitMessage ;
	m_sOtherExitMessage = rhs.m_sOtherExitMessage ;
	m_sMyEnterMessage = rhs.m_sMyEnterMessage ;
	m_sOtherEnterMessage = rhs.m_sOtherEnterMessage ;

	return *this ;
}

void CPsyMudRoomExit::SetDestination (CPsyMudObject * rm)
{
	m_Destination = rm ;

	if (m_sDescription == "")
	{
		m_sDescription = ((CPsyMudRoom *)rm)->GetName() ;
	}
}

