%{
//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version. Pleae keep all headers and
// documentation (including development credits) intact.
//
//=======================================================================

// PXL stands for Psymud eXtension Language

// ********************************************************************************
// Please note that this must be compiled as a case insensitive parser using flex
// ********************************************************************************

/* Comments and definitions goes here. So does options. */
/* Specifically, if you want to use more than one lexical file in each */
/* project you will have to use the option '%option prefix="whatever"'.*/
/* This will replace the "yy" part in function and variable names with */
/* the string "whatever". For more information, as well as documentation */
/* of other options, see the GNU Flex manual. */

#include "pxl_tokens.h"

int	lineno = 1 ;

%}

OPTIONAL_WHITESPACE		[ \t]*
WHITESPACE				[ \t]+
NEWLINE					\n
STRING					\"*\"
ADD_OP					"+"



%%

{WHITESPACE}				{ /* do nothing, whitespace */ ; }
{NEWLINE}					{ lineno++ ; }
{STRING}					{ /* TO DO: Add string to string table */ ; }

{ADD_OP}					{ return TOK_ADD_OP ; }

Sub							{ return TOK_SUB ; }
End{WHITESPACE}Sub			{ return TOK_END_SUB ; }

Function					{ return TOK_FUNCTION ; }
End{WHITESPACE}Function		{ return TOK_END_FUNCTION ; }

Handler						{ return TOK_HANDLER ; }
End{WHITESPACE}Handler		{ return TOK_END_HANDLER ; }

ExecuteCommand				{ return TOK_EXECUTE_COMMAND ; }


.							{ return yytext[0] ; }

%%



