//=======================================================================
// This file is a component of PsyMUD written by Peter M. Brown
// copyright            : (C) 2000 by Peter M Brown
// email                : pmbrown@cablespeed.com
//=======================================================================
//                                                                          
// This program is free software; you can redistribute it and/or modify  
// it under the terms of the GNU General Public License as published by  
// the Free Software Foundation; either version 2 of the License, or     
// (at your option) any later version. Pleae keep all headers and 
// documentation (including development credits) intact.
//                                                                          
//=======================================================================


#include "timeutil.h"

void CalculateTimeDifference(struct timeval& tmResult, struct timeval& tmFirst, struct timeval& tmSecond)
{
	if (tmFirst.tv_sec < tmSecond.tv_sec)
	{
		// never go below zero
		tmResult.tv_sec = 0 ;
		tmResult.tv_usec = 0 ;
	}
	else if (tmFirst.tv_sec == tmSecond.tv_sec)
	{
		if (tmFirst.tv_usec < tmSecond.tv_usec)
		{
			// never go below zero
			tmResult.tv_sec = 0 ;
			tmResult.tv_usec = 0 ;	
		}
		else
		{
			// seconds are same, subtract tmSecond microseconds from tmFirst microseconds
			tmResult.tv_sec = 0 ;
			tmResult.tv_usec = tmFirst.tv_usec - tmSecond.tv_usec ;
		}
	}
	else
	{
		tmResult.tv_sec = tmFirst.tv_sec - tmSecond.tv_sec ;

		if (tmFirst.tv_usec < tmSecond.tv_usec)
		{
			// roll back one partial second
			tmResult.tv_sec = tmFirst.tv_usec + 1000000 - tmSecond.tv_usec ;
			tmResult.tv_sec-- ;
		}
		else
		{
			tmResult.tv_usec = tmFirst.tv_usec - tmSecond.tv_usec ;
		}
	}
}